/*..........................................................................*/
/*                                                                          */
/*      L a s t W a v e    P a c k a g e 'mrw' 1.0                          */
/*                                                                          */
/*..........................................................................*/
/*                                                                          */
/*      This program is a free software, you can redistribute it and/or     */
/*      modify it under the terms of the GNU General Public License as      */
/*      published by the Free Software Foundation; either version 2 of the  */
/*      License, or (at your option) any later version                      */
/*                                                                          */
/*      This program is distributed in the hope that it will be useful,     */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of      */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       */
/*      GNU General Public License for more details.                        */
/*                                                                          */
/*      You should have received a copy of the GNU General Public License   */
/*      along with this program (in a file named COPYRIGHT);                */
/*      if not, write to the Free Software Foundation, Inc.,                */
/*      59 Temple Place, Suite 330, Boston, MA  02111-1307  USA             */
/*                                                                          */
/*..........................................................................*/


#include "lastwave.h"


extern void C_MrwInitGmm(char **),C_GMM(char **);


static CProc mrwCommands[] = {

  "mrwinitgmm",C_MrwInitGmm,"{{{<mrw> <signal_lags>  <tau> [-s]} {Initializes GMM with the mrw <mrw> using the \
ln of the increments on time scale <tau>. The moments that are fitted are, the variance of the mrw increments and the variance and the covariance corresponding \
to lags <signal_lags> of the ln of the mrw increments. (Let us note that the <signal_lags> should be an increasing signal and should not include lag 0). It returns the historical \
sqrt(variance). If -s then no init is made, the command only returns the sqrt(variance).}}}",
  "gmm",C_GMM,"{{{cut <param1> ... <paramN>} {Computes a cut in the function to minimize. One of the <param...> must be a range/signal.}} \
  {{dcut <parameter_index> <param1> ... <paramN>} {Computes a cut in the gradient of the function to minimize (in the direction of <parameter_index>). One of the <param...> must be a range/signal.}} \
  {{matrix <parameters>} {Gets the GMM weight matrix corresponding to parameters <parameters>}} \
  {{moment <parameters>} {Gets the GMM vector corresponding to parameters <parameters>}} \
  {{start {listv of <initParams>} [<nGMMIteration>=1] [<GMMmatrix>]} {Starts estimation with the best parameters in the listv of <initParams> (expressed as a signal). In the case of MRW, the parameters are \
    <sigma^2,lambda2,ln(T)>. This command returns the estimated parameters.}}}",
  
  NULL,NULL,NULL
};


static  CProcTable mrwTable = {mrwCommands, "mrw", "Commands related to the mrw package"};


void LoadMRWPackage(void) 
{ 
  AddCProcTable(&mrwTable); 
} 


void DeclareMRWPackage(void)
{  
  DeclarePackage("mrw",LoadMRWPackage,2008,"1.0","E.Bacry and J.F.Muzy",
                 "Package allowing simulation/estimation of log-normal MRW processes.");
}

